/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.ConfigRestriccionPagoDAO;
import com.rjconsultores.ventaboletos.entidad.ConfigRestriccionPago;
import com.rjconsultores.ventaboletos.entidad.FormaPago;
import com.rjconsultores.ventaboletos.entidad.RestriccionPago;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Administrador
 */
@Repository("configRestriccionPagoDAO")
public class ConfigRestriccionPagoHibernateDAO
        extends GenericHibernateDAO<ConfigRestriccionPago, Integer>
        implements ConfigRestriccionPagoDAO {

    @Autowired
    public ConfigRestriccionPagoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<ConfigRestriccionPago> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));

        return c.list();
    }

    public List<ConfigRestriccionPago> buscar(FormaPago formaPago,
            RestriccionPago restriccionPago) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));

        c.add(Restrictions.eq("restriccion", restriccionPago));
        c.add(Restrictions.eq("formaPago", formaPago));

        return c.list();
    }

    public Map<Integer, ConfigRestriccionPago> buscar(FormaPago formaPago) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("formaPago", formaPago));

        Map<Integer, ConfigRestriccionPago> mapRespuesta = new LinkedHashMap<Integer, ConfigRestriccionPago>();

        List<ConfigRestriccionPago> list = c.list();
        if (!list.isEmpty()) {
            for (ConfigRestriccionPago crp : list) {
                mapRespuesta.put(crp.getRestriccion().getRestriccionId().intValue(), crp);
            }
        }

        return mapRespuesta;
    }
}
