/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.PricingEspecificoDAO;
import com.rjconsultores.ventaboletos.entidad.PricingEspecifico;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Rafius
 */
@Repository("pricingEspecificoDAO")
public class PricingEspecificoHibernateDAO extends GenericHibernateDAO<PricingEspecifico, Integer>
        implements PricingEspecificoDAO {

    @Autowired
    public PricingEspecificoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<PricingEspecifico> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));

        return c.list();
    }

    public List<PricingEspecifico> buscarPorNome(PricingEspecifico pricingEspecifico) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("nombPricing", pricingEspecifico.getNombPricing()));

        return c.list();
    }
}
