/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.PricingDAO;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import java.math.BigDecimal;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Rafius
 */
@Repository("pricingDAO")
public class PricingHibernateDAO extends GenericHibernateDAO<Pricing, Integer>
        implements PricingDAO {

    @Autowired
    public PricingHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<Pricing> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));

        return c.list();
    }

    public List<Pricing> buscar(String nombPricing, Empresa empresa,
            Short cantboleto, Integer cantdiasanticipacion,
            BigDecimal descuentoporcentaje, BigDecimal descuentoporcredondo) {

        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));

        c.add(Restrictions.eq("nombPricing", nombPricing));
        c.add(Restrictions.eq("empresa", empresa));
        c.add(Restrictions.eq("cantboleto", cantboleto));
        c.add(Restrictions.eq("cantdiasanticipacion", cantdiasanticipacion));
        if (descuentoporcentaje != null) {
            c.add(Restrictions.eq("descuentoporcentaje", descuentoporcentaje));
        }
        if (descuentoporcredondo != null) {
            c.add(Restrictions.eq("descuentoporcredondo", descuentoporcredondo));
        }

        return c.list();
    }

    public List<Pricing> buscarPorNombre(String nombPricing) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));

        c.add(Restrictions.eq("nombPricing", nombPricing));

        return c.list();
    }
}
