/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.ReservacionCtrlDAO;
import com.rjconsultores.ventaboletos.entidad.ReservacionCtrl;
import com.rjconsultores.ventaboletos.entidad.VigenciaTarifa;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import org.hibernate.Query;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Administrador
 */
@Repository("reservacionCtrlDAO")
public class ReservacionCtrlHibernateDAO
        extends GenericHibernateDAO<ReservacionCtrl, Integer>
        implements ReservacionCtrlDAO {

    @Autowired
    public ReservacionCtrlHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<ReservacionCtrl> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));

        return c.list();
    }

    @Override
    public List<ReservacionCtrl> buscar(ReservacionCtrl reservacionCtrl) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("descConfig", reservacionCtrl.getDescConfig()));

        return c.list();
    }

    @Override
    public List<ReservacionCtrl> buscarFechaTraslapa(ReservacionCtrl reservacionCtrlt) {

        Calendar fecinicio = Calendar.getInstance();
        fecinicio.setTime(reservacionCtrlt.getFecinicio());
		
		Calendar fecfinal = Calendar.getInstance();
		fecfinal.setTime(reservacionCtrlt.getFecfinal());
		

		Criteria c = this.getSession().createCriteria(ReservacionCtrl.class);
		c.add(Restrictions.eq("activo", Boolean.TRUE));
		c.add(Restrictions.ge("fecfinal", fecinicio.getTime()));
		c.add(Restrictions.le("fecinicio", fecfinal.getTime()));

        return c.list();
    }
}
