/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.TramoServicioDAO;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Tramo;
import com.rjconsultores.ventaboletos.entidad.TramoServicio;
import com.rjconsultores.ventaboletos.entidad.TramoTiempo;
import com.rjconsultores.ventaboletos.entidad.Via;

import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Rafius
 */
@Repository("tramoServicioDAO")
public class TramoServicioHibernateDAO extends GenericHibernateDAO<TramoServicio, Integer>
        implements TramoServicioDAO {

    @Autowired
    public TramoServicioHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    public List<TramoServicio> buscarPorTramo(Tramo tramo) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("tramo", tramo));

        return c.list();
    }

    public List<TramoServicio> buscarPorTramo(Tramo tramo, ClaseServicio clase) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("tramo", tramo));
        c.add(Restrictions.eq("claseServicio", clase));

        return c.list();
    }

	@Override
	public TramoServicio buscar(Parada origen, Parada destino, Via via, ClaseServicio clase) {
		
			Criteria c = getSession().createCriteria(getPersistentClass());
			c.add(Restrictions.eq("activo", Boolean.TRUE));
			Criteria cTramo = c.createCriteria("tramo");
			cTramo.add(Restrictions.eq("origem", origen));
			cTramo.add(Restrictions.eq("destino", destino));
			cTramo.add(Restrictions.eq("via", via));
			cTramo.add(Restrictions.eq("activo", Boolean.TRUE));
			c.add(Restrictions.eq("claseServicio", clase));

			return  (TramoServicio) c.uniqueResult();
		
	}
}
