/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.SequenceGenerator;

/**
 *
 * @author Administrador
 */
@Entity
@SequenceGenerator(name = "CATEGORIA_SEQ", sequenceName = "CATEGORIA_SEQ", allocationSize = 1)
@Table(name = "CATEGORIA")
public class Categoria implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "CATEGORIA_SEQ")
    @Column(name = "CATEGORIA_ID")
    private Integer categoriaId;
    @Column(name = "DESCCATEGORIA")
    private String desccategoria;
    @Column(name = "ACTIVO")
    private Boolean activo;
    //CAmpos retirados
//    @Column(name = "INDVENDEINTERNET")
//    private Boolean vendeInternet;
//    @Column(name = "INDVENDEAGENCIAWEB")
//    private Boolean vendeAgenciaWeb;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @OneToMany(mappedBy = "categoria", cascade = CascadeType.ALL)
    private List<CategoriaDescuento> categoriaDescuentoList;
    @OneToMany(mappedBy = "categoria", cascade = CascadeType.ALL)
    private List<ReservacionCategoria> reservacionCategoriaList;

    public Categoria() {
    }

    public Categoria(Integer categoriaId) {
        this.categoriaId = categoriaId;
    }

    public Integer getCategoriaId() {
        return categoriaId;
    }

    public void setCategoriaId(Integer categoriaId) {
        this.categoriaId = categoriaId;
    }

    public String getDesccategoria() {
        return desccategoria;
    }

    public void setDesccategoria(String desccategoria) {
        this.desccategoria = desccategoria;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public List<CategoriaDescuento> getCategoriaDescuentoList() {
        //return categoriaDescuentoList;
        List<CategoriaDescuento> rcList = new ArrayList<CategoriaDescuento>();
        for (CategoriaDescuento rc : this.categoriaDescuentoList) {
            if (rc.getActivo() == Boolean.TRUE) {
                rcList.add(rc);
            }
        }
        return rcList;
    }

    public void setCategoriaDescuentoList(List<CategoriaDescuento> categoriaDescuentoList) {
        this.categoriaDescuentoList = categoriaDescuentoList;
    }

    public List<ReservacionCategoria> getReservacionCategoriaList() {
        //return reservacionCategoriaList;
        List<ReservacionCategoria> rcList = new ArrayList<ReservacionCategoria>();
        for (ReservacionCategoria rc : this.reservacionCategoriaList) {
            if (rc.getActivo() == Boolean.TRUE) {
                rcList.add(rc);
            }
        }
        return rcList;
    }

    public void setReservacionCategoriaList(List<ReservacionCategoria> reservacionCategoriaList) {
        this.reservacionCategoriaList = reservacionCategoriaList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (categoriaId != null ? categoriaId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Categoria)) {
            return false;
        }
        Categoria other = (Categoria) object;
        if ((this.categoriaId == null && other.categoriaId != null) || (this.categoriaId != null && !this.categoriaId.equals(other.categoriaId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return this.getDesccategoria();
    }
}
