/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.SequenceGenerator;

/**
 *
 * @author Administrador
 */
@Entity
@SequenceGenerator(name = "CLASE_SERVICIO_SEQ", sequenceName = "CLASE_SERVICIO_SEQ", allocationSize = 1)
@Table(name = "CLASE_SERVICIO")
public class ClaseServicio implements Serializable {

	public final static short TODOS = -1;
	
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "CLASE_SERVICIO_SEQ")
    @Column(name = "CLASESERVICIO_ID")
    private Short claseservicioId;
    @Column(name = "DESCCLASE")
    private String descclase;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Basic(optional = false)
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @OneToMany(mappedBy = "claseServicio")
    private List<CategoriaClase> categoriaClaseList;
    @OneToMany(mappedBy = "claseServicio")
    private List<ReservacionClase> reservacionClaseList;
    @OneToMany(mappedBy = "claseServicio")
    private List<TramoTiempo> tramoTiempoList;
    @Column(name = "EQUIVALENCIA_ID")
    private String equivalenciaId;
    @Column(name = "EQUIVALENCIAELEKTRA_ID")
    private String equivalenciaElektraId;
    @OneToMany(mappedBy = "claseServicio")
    private List<TarifaHist> tarifaHistList;
    @OneToMany(mappedBy = "claseServicio")
    private List<Corrida> corridaList;

    public ClaseServicio() {
    }

    public ClaseServicio(Short claseservicioId) {
        this.claseservicioId = claseservicioId;
    }

    public ClaseServicio(Short claseservicioId, Date fecmodif) {
        this.claseservicioId = claseservicioId;
        this.fecmodif = fecmodif;
    }

    public Short getClaseservicioId() {
        return claseservicioId;
    }

    public void setClaseservicioId(Short claseservicioId) {
        this.claseservicioId = claseservicioId;
    }

    public String getDescclase() {
        return descclase;
    }

    public void setDescclase(String descclase) {
        this.descclase = descclase;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public List<CategoriaClase> getCategoriaClaseList() {
        List<CategoriaClase> tmp = new ArrayList<CategoriaClase>();
        if (categoriaClaseList != null) {
            for (CategoriaClase cc : this.categoriaClaseList) {
                if (cc.getActivo()) {
                    tmp.add(cc);
                }
            }
        }

        return tmp;
    }

    public void setCategoriaClaseList(List<CategoriaClase> categoriaClaseList) {
        this.categoriaClaseList = categoriaClaseList;
    }

    public List<ReservacionClase> getReservacionClaseList() {
        List<ReservacionClase> tmp = new ArrayList<ReservacionClase>();
        for (ReservacionClase rc : this.reservacionClaseList) {
            if (rc.getActivo()) {
                tmp.add(rc);
            }
        }

        return tmp;
    }

    public List<Corrida> getCorridaList() {
        return corridaList;
    }

    public void setCorridaList(List<Corrida> corridaList) {
        this.corridaList = corridaList;
    }

    public void setReservacionClaseList(List<ReservacionClase> reservacionClaseList) {
        this.reservacionClaseList = reservacionClaseList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (claseservicioId != null ? claseservicioId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof ClaseServicio)) {
            return false;
        }
        ClaseServicio other = (ClaseServicio) object;
        if ((this.claseservicioId == null && other.claseservicioId != null) || (this.claseservicioId != null && !this.claseservicioId.equals(other.claseservicioId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return getDescclase();
    }

    public List<TramoTiempo> getTramoTiempoList() {
        return tramoTiempoList;
    }

    public void setTramoTiempoList(List<TramoTiempo> tramoTiempoList) {
        this.tramoTiempoList = tramoTiempoList;
    }

    public String getEquivalenciaId() {
        return equivalenciaId;
    }

    public void setEquivalenciaId(String equivalenciaId) {
        this.equivalenciaId = equivalenciaId;
    }

    public List<TarifaHist> getTarifaHistList() {
        return tarifaHistList;
    }

    public void setTarifaHistList(List<TarifaHist> tarifaHistList) {
        this.tarifaHistList = tarifaHistList;
    }

    public String getEquivalenciaElektraId() {
        return equivalenciaElektraId;
    }

    public void setEquivalenciaElektraId(String equivalenciaElektraId) {
        this.equivalenciaElektraId = equivalenciaElektraId;
    }
}
