/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author Administrador
 */
@Entity
@SequenceGenerator(name = "FORMA_PAGO_DET_SEQ", sequenceName = "FORMA_PAGO_DET_SEQ", allocationSize = 1)
@Table(name = "FORMA_PAGO_DET")
public class FormaPagoDet implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "FORMAPAGODET_ID")
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "FORMA_PAGO_DET_SEQ")
    private Integer formapagodetId;
    @Column(name = "CARGOSEXTRAS")
    private BigDecimal cargosextras;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Basic(optional = false)
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @JoinColumn(name = "PUNTOVENTA_ID", referencedColumnName = "PUNTOVENTA_ID")
    @ManyToOne
    private PuntoVenta puntoVenta;
    
    
    @OneToOne
    @JoinColumn(name = "FORMAPAGO_ID")
    private FormaPago formaPago;

    public FormaPagoDet() {
    }

    public FormaPagoDet(Integer formapagodetId) {
        this.formapagodetId = formapagodetId;
    }

    public FormaPagoDet(Integer formapagodetId, Date fecmodif) {
        this.formapagodetId = formapagodetId;
        this.fecmodif = fecmodif;
    }

    public Integer getFormapagodetId() {
        return formapagodetId;
    }

    public void setFormapagodetId(Integer formapagodetId) {
        this.formapagodetId = formapagodetId;
    }

    public BigDecimal getCargosextras() {
        return cargosextras;
    }

    public void setCargosextras(BigDecimal cargosextras) {
        this.cargosextras = cargosextras;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public PuntoVenta getPuntoVenta() {
        return puntoVenta;
    }

    public void setPuntoVenta(PuntoVenta puntoVenta) {
        this.puntoVenta = puntoVenta;
    }


    public FormaPago getFormaPago() {
        return formaPago;
    }

    public void setFormaPago(FormaPago formaPago) {
        this.formaPago = formaPago;
    }


    @Override
    public int hashCode() {
        int hash = 0;
        hash += (formapagodetId != null ? formapagodetId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof FormaPagoDet)) {
            return false;
        }
        FormaPagoDet other = (FormaPagoDet) object;
        if ((this.formapagodetId == null && other.formapagodetId != null) || (this.formapagodetId != null && !this.formapagodetId.equals(other.formapagodetId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.entidad.FormaPagoDet[formapagodetId=" + formapagodetId + "]";
    }
}
