/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.SequenceGenerator;

/**
 *
 * @author Rafius
 */
@Entity
@SequenceGenerator(name = "RUTA_SECUENCIA_SEQ", sequenceName = "RUTA_SECUENCIA_SEQ", allocationSize=1)
@Table(name = "RUTA_SECUENCIA")
public class RutaSecuencia implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "RUTA_SECUENCIA_SEQ")
    @Column(name = "RUTASECUENCIA_ID")
    private Integer rutasecuenciaId;
    @Column(name = "NUMSECUENCIA")
    private Short numsecuencia;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @JoinColumn(name = "TRAMO_ID", referencedColumnName = "TRAMO_ID")
    @ManyToOne
    private Tramo tramo;
    @JoinColumn(name = "RUTA_ID", referencedColumnName = "RUTA_ID")
    @ManyToOne
    private Ruta ruta;

    public RutaSecuencia() {
    }

    public RutaSecuencia(Integer rutasecuenciaId) {
        this.rutasecuenciaId = rutasecuenciaId;
    }

    public Integer getRutasecuenciaId() {
        return rutasecuenciaId;
    }

    public void setRutasecuenciaId(Integer rutasecuenciaId) {
        this.rutasecuenciaId = rutasecuenciaId;
    }

    public Short getNumsecuencia() {
        return numsecuencia;
    }

    public void setNumsecuencia(Short numsecuencia) {
        this.numsecuencia = numsecuencia;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public Tramo getTramo() {
        return tramo;
    }

    public void setTramo(Tramo tramo) {
        this.tramo = tramo;
    }

    public Ruta getRuta() {
        return ruta;
    }

    public void setRuta(Ruta ruta) {
        this.ruta = ruta;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (rutasecuenciaId != null ? rutasecuenciaId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof RutaSecuencia)) {
            return false;
        }
        RutaSecuencia other = (RutaSecuencia) object;
        if ((this.rutasecuenciaId == null && other.rutasecuenciaId != null) || (this.rutasecuenciaId != null && !this.rutasecuenciaId.equals(other.rutasecuenciaId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.entidad.RutaSecuencia[rutasecuenciaId=" + rutasecuenciaId + "]";
    }
}
