/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author gleimar
 */
@Entity
@SequenceGenerator(name = "SEGURO_TARIFA_SEQ", sequenceName = "SEGURO_TARIFA_SEQ", allocationSize = 1)
@Table(name = "SEGURO_TARIFA")
public class SeguroTarifa implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "SEGURO_TARIFA_SEQ")
    @Column(name = "SEGUROTARIFA_ID")
    private Integer segurotarifaId;
    @Column(name = "VALORTAXA")
    private BigDecimal valortarifa;
    @Column(name = "VALORTARIFAATE")
    private BigDecimal valortarifaate;
    @JoinColumn(name = "ORGAOCONCEDENTE_ID", referencedColumnName = "ORGAOCONCEDENTE_ID")
    @ManyToOne
    private OrgaoConcedente orgaoconcedente;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;

    public SeguroTarifa() {
    }

    public SeguroTarifa(Integer segurotarifaId) {
        this.segurotarifaId = segurotarifaId;
    }

    public Integer getSegurotarifaId() {
        return segurotarifaId;
    }

    public void setSegurotarifaId(Integer segurotarifaId) {
        this.segurotarifaId = segurotarifaId;
    }

    public BigDecimal getValortarifa() {
        return valortarifa;
    }

    public void setValortarifa(BigDecimal valortarifa) {
        this.valortarifa = valortarifa;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (segurotarifaId != null ? segurotarifaId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof SeguroTarifa)) {
            return false;
        }
        SeguroTarifa other = (SeguroTarifa) object;
        if ((this.segurotarifaId == null && other.segurotarifaId != null) || (this.segurotarifaId != null && !this.segurotarifaId.equals(other.segurotarifaId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.entidad.SeguroTarifa[ segurotarifaId=" + segurotarifaId + " ]";
    }

    public BigDecimal getValortarifaate() {
        return valortarifaate;
    }

    public void setValortarifaate(BigDecimal valortarifaate) {
        this.valortarifaate = valortarifaate;
    }

    public OrgaoConcedente getOrgaoconcedente() {
        return orgaoconcedente;
    }

    public void setOrgaoconcedente(OrgaoConcedente orgaoconcedente) {
        this.orgaoconcedente = orgaoconcedente;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }
}
