/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author rodrigo
 */
@Entity
@SequenceGenerator(name = "TARIFA_SEQ", sequenceName = "TARIFA_SEQ", allocationSize = 1)
@Table(name = "TARIFA")
public class Tarifa implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "TARIFA_SEQ")
    @Column(name = "TARIFA_ID")
    private Integer tarifaId;
    @Column(name = "PRECIO")
    private BigDecimal precio;
    @Column(name = "IMPORTETAXAEMBARQUE")
    private BigDecimal importetaxaembarque;
    @Column(name = "IMPORTEPEDAGIO")
    private BigDecimal importepedagio;
    @Column(name = "IMPORTEOUTROS")
    private BigDecimal importeoutros;
    @Column(name = "IMPORTESEGURO")
    private BigDecimal importeseguro;
    @Column(name = "PRECIOORIGINAL")
    private BigDecimal preciooriginal;
    @Column(name = "STATUSTARIFA")
    private String statustarifa;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @OneToOne
    @JoinColumn(name = "TRAMO_ID")
    private Tramo tramo;
    @OneToOne
    @JoinColumn(name = "MARCA_ID")
    private Marca marca;
    @OneToOne
    @JoinColumn(name = "CLASESERVICIO_ID")
    private ClaseServicio claseServicio;
    @OneToOne
    @JoinColumn(name = "MONEDA_ID")
    private Moneda moneda;
    @OneToOne
    @JoinColumn(name = "VIGENCIATARIFA_ID")
    private VigenciaTarifa vigenciaTarifa;
    @Column(name = "PRECIOREDABIERTO")
    private BigDecimal precioredabierto;
    @OneToMany(cascade = CascadeType.ALL)
    @JoinColumn(name = "TARIFA_ID", referencedColumnName = "TARIFA_ID")
    private List<TarifaTipoptovta> lsTarifaTipoptovta;
    @OneToMany(cascade = CascadeType.ALL)
    @JoinColumn(name = "TARIFA_ID", referencedColumnName = "TARIFA_ID")
    private List<TarifaCategoria> lsTarifaCategoria;
    @OneToOne
    @JoinColumn(name = "ORIGEN_ID")
    private Parada origen;
    @OneToOne
    @JoinColumn(name = "DESTINO_ID")
    private Parada destino;
    @OneToOne
    @JoinColumn(name = "RUTA_ID")
    private Ruta ruta;
    @OneToOne
    @JoinColumn(name = "ORGAOCONCEDENTE_ID")
    private OrgaoConcedente orgaoConcedente;

	public Tarifa() {
    }
	
	public OrgaoConcedente getOrgaoConcedente() {
		return orgaoConcedente;
	}

	public void setOrgaoConcedente(OrgaoConcedente orgaoConcedente) {
		this.orgaoConcedente = orgaoConcedente;
	}

	public Ruta getRuta() {
		return ruta;
	}

	public void setRuta(Ruta ruta) {
		this.ruta = ruta;
	}
    public Tarifa(Integer tarifaId) {
        this.tarifaId = tarifaId;
    }

    public Integer getTarifaId() {
        return tarifaId;
    }

    public void setTarifaId(Integer tarifaId) {
        this.tarifaId = tarifaId;
    }

    public BigDecimal getPrecio() {
        return precio;
    }

    public void setPrecio(BigDecimal precio) {
        this.precio = precio;
    }

    public BigDecimal getPreciooriginal() {
        return preciooriginal;
    }

    public void setPreciooriginal(BigDecimal preciooriginal) {
        this.preciooriginal = preciooriginal;
    }

    public String getStatustarifa() {
        return statustarifa;
    }

    public void setStatustarifa(String statustarifa) {
        this.statustarifa = statustarifa;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public ClaseServicio getClaseServicio() {
        return claseServicio;
    }

    public void setClaseServicio(ClaseServicio claseServicio) {
        this.claseServicio = claseServicio;
    }

    public Marca getMarca() {
        return marca;
    }

    public void setMarca(Marca marca) {
        this.marca = marca;
    }

    public Moneda getMoneda() {
        return moneda;
    }

    public void setMoneda(Moneda moneda) {
        this.moneda = moneda;
    }

    public Tramo getTramo() {
        return tramo;
    }

    public void setTramo(Tramo tramo) {
        this.tramo = tramo;
    }

    public VigenciaTarifa getVigenciaTarifa() {
        return vigenciaTarifa;
    }

    public void setVigenciaTarifa(VigenciaTarifa vigenciaTarifa) {
        this.vigenciaTarifa = vigenciaTarifa;
    }

    public BigDecimal getPrecioredabierto() {
        return precioredabierto;
    }

    public void setPrecioredabierto(BigDecimal precioredabierto) {
        this.precioredabierto = precioredabierto;
    }

    public List<TarifaCategoria> getLsTarifaCategoria() {
        List<TarifaCategoria> tmp = new ArrayList<TarifaCategoria>();
        if (lsTarifaCategoria != null) {
            for (TarifaCategoria ddab : this.lsTarifaCategoria) {
                if (ddab.getActivo()) {
                    tmp.add(ddab);
                }
            }
        }

        this.lsTarifaCategoria = tmp;

        return tmp;
    }

    public void setLsTarifaCategoria(List<TarifaCategoria> lsTarifaCategoria) {
        this.lsTarifaCategoria = lsTarifaCategoria;
    }

    public List<TarifaTipoptovta> getLsTarifaTipoptovta() {
        List<TarifaTipoptovta> tmp = new ArrayList<TarifaTipoptovta>();
        if (lsTarifaTipoptovta != null) {
            for (TarifaTipoptovta ddab : this.lsTarifaTipoptovta) {
                if (ddab.getActivo()) {
                    tmp.add(ddab);
                }
            }
        }

        this.lsTarifaTipoptovta = tmp;

        return tmp;
    }

    public void setLsTarifaTipoptovta(List<TarifaTipoptovta> lsTarifaTipoptovta) {
        this.lsTarifaTipoptovta = lsTarifaTipoptovta;
    }
    

    public Parada getOrigen() {
		return origen;
	}

	public void setOrigen(Parada origen) {
		this.origen = origen;
	}

	public Parada getDestino() {
		return destino;
	}

	public void setDestino(Parada destino) {
		this.destino = destino;
	}

	@Override
    public int hashCode() {
        int hash = 0;
        hash += (tarifaId != null ? tarifaId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Tarifa)) {
            return false;
        }
        Tarifa other = (Tarifa) object;
        if ((this.tarifaId == null && other.tarifaId != null) || (this.tarifaId != null && !this.tarifaId.equals(other.tarifaId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.entidad.Tarifa[tarifaId=" + tarifaId + "]";
    }

	public BigDecimal getImportetaxaembarque() {
		return importetaxaembarque;
	}

	public void setImportetaxaembarque(BigDecimal importetaxaembarque) {
		this.importetaxaembarque = importetaxaembarque;
	}

	public BigDecimal getImportepedagio() {
		return importepedagio;
	}

	public void setImportepedagio(BigDecimal importepedagio) {
		this.importepedagio = importepedagio;
	}

	public BigDecimal getImporteoutros() {
		return importeoutros;
	}

	public void setImporteoutros(BigDecimal importeoutros) {
		this.importeoutros = importeoutros;
	}

	public BigDecimal getImporteseguro() {
		return importeseguro;
	}

	public void setImporteseguro(BigDecimal importeseguro) {
		this.importeseguro = importeseguro;
	}
}
