/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.List;

import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.springframework.security.core.Authentication;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.userdetails.UserDetails;

/**
 *
 * @author rodrigo
 */
@Entity
@SequenceGenerator(name = "USUARIO_SEQ", sequenceName = "USUARIO_SEQ", allocationSize = 1)
@Table(name = "USUARIO")
public class Usuario implements Serializable, Authentication, UserDetails {

    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "USUARIO_SEQ")
    @Basic(optional = false)
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @Column(name = "NOMBUSUARIO")
    private String nombusuario;
    @Column(name = "NOMBPATERNO")
    private String nombpaterno;
    @Column(name = "NOMBMATERNO")
    private String nombmaterno;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIOMODIF_ID")
    private Integer usuariomodifId;
    @Column(name = "DESCCONTRASENA")
    private String senha;
    @Column(name = "CVEUSUARIO")
    private String claveUsuario;
    @Column(name = "DESCCORREO")
    private String descCorreo;
    @OneToMany(mappedBy = "usuario", cascade = CascadeType.ALL)
    private List<UsuarioPerfil> usuarioPerfilList;
    @OneToOne
    @JoinColumn(name = "EMPLEADO_ID")
    private Empleado empleado;

    public String getClaveUsuario() {
        return claveUsuario;
    }

    public void setClaveUsuario(String claveUsuario) {
        this.claveUsuario = claveUsuario;
    }

    public Usuario() {
    }

    public Usuario(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public String getNombusuario() {
        return nombusuario;
    }

    public void setNombusuario(String nombusuario) {
        this.nombusuario = nombusuario;
    }

    public String getNombpaterno() {
        return nombpaterno;
    }

    public void setNombpaterno(String nombpaterno) {
        this.nombpaterno = nombpaterno;
    }

    public String getNombmaterno() {
        return nombmaterno;
    }

    public void setNombmaterno(String nombmaterno) {
        this.nombmaterno = nombmaterno;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuariomodifId() {
        return usuariomodifId;
    }

    public void setUsuariomodifId(Integer usuariomodifId) {
        this.usuariomodifId = usuariomodifId;
    }

    public String getSenha() {
        return senha;
    }

    public void setSenha(String senha) {
        this.senha = senha;
    }

    public List<UsuarioPerfil> getUsuarioPerfilList() {
        List<UsuarioPerfil> tmp = new ArrayList<UsuarioPerfil>();
        if (usuarioPerfilList != null) {
            for (UsuarioPerfil cp : this.usuarioPerfilList) {
                if (cp.getActivo()) {
                    tmp.add(cp);
                }
            }
        }

        return tmp;
    }

    public void setUsuarioPerfilList(List<UsuarioPerfil> usuarioPerfilList) {
        this.usuarioPerfilList = usuarioPerfilList;
    }

    public Empleado getEmpleado() {
        return empleado;
    }

    public void setEmpleado(Empleado empleado) {
        this.empleado = empleado;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (usuarioId != null ? usuarioId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Usuario)) {
            return false;
        }
        Usuario other = (Usuario) object;
        if ((this.usuarioId == null && other.usuarioId != null) || (this.usuarioId != null && !this.usuarioId.equals(other.usuarioId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.entidad.Usuario[usuarioId=" + usuarioId + "]";
    }

    public Collection<GrantedAuthority> getAuthorities() {
        return new ArrayList<GrantedAuthority>();
    }

    public String getPassword() {
        return this.senha;
    }

    public String getUsername() {
        return this.nombusuario;
    }

    public boolean isAccountNonExpired() {
        return true;
    }

    public boolean isAccountNonLocked() {
        return true;
    }

    public boolean isCredentialsNonExpired() {
        return true;
    }

    public boolean isEnabled() {
        return true;
    }

    public Object getCredentials() {
        return new Object();
    }

    public Object getDetails() {
        return new Object();
    }

    public Object getPrincipal() {
        return this;
    }

    public boolean isAuthenticated() {
        return Boolean.TRUE;
    }

    public void setAuthenticated(boolean bln) throws IllegalArgumentException {
    }

    public String getName() {
        return this.getNombusuario();
    }

    public String getDescCorreo() {
        return descCorreo;
    }

    public void setDescCorreo(String descCorreo) {
        this.descCorreo = descCorreo;
    }
}
