/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.CiudadDAO;
import com.rjconsultores.ventaboletos.entidad.Ciudad;
import com.rjconsultores.ventaboletos.entidad.Estado;
import com.rjconsultores.ventaboletos.entidad.Plaza;
import com.rjconsultores.ventaboletos.service.CiudadService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author MCosso
 */
@Service("ciudadService")
public class CiudadServiceImpl implements CiudadService {

    @Autowired
    private CiudadDAO ciudadDAO;

    public List<Ciudad> obtenerTodos() {
        return ciudadDAO.obtenerTodos();
    }

    public Ciudad obtenerID(Integer id) {
        return ciudadDAO.obtenerID(id);
    }

    @Transactional
    public Ciudad suscribir(Ciudad entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return ciudadDAO.suscribir(entidad);
    }

    @Transactional
    public Ciudad actualizacion(Ciudad entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return ciudadDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Ciudad entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        ciudadDAO.actualizacion(entidad);
    }

    public List<Ciudad> buscar(String nombciudad, Estado estado, Plaza plaza) {
        return ciudadDAO.buscar(nombciudad, estado, plaza);
    }

    public List<Ciudad> buscaLike(String strCiudad){
        return ciudadDAO.buscaLike(strCiudad);
    }

	@Override
	public List<Ciudad> buscarPorEstado(Estado estado) {
		return ciudadDAO.buscarPorEstado(estado);
	}
}
