package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.CoeficienteTarifaDAO;
import com.rjconsultores.ventaboletos.entidad.CoeficienteTarifa;
import com.rjconsultores.ventaboletos.service.CoeficienteTarifaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("coeficienteTarifaService")
public class CoeficienteTarifaServiceImpl implements CoeficienteTarifaService {

	@Autowired
	private CoeficienteTarifaDAO coeficienteTarifaDAO;

	public List<CoeficienteTarifa> obtenerTodos() {
		return coeficienteTarifaDAO.obtenerTodos();
	}

	public CoeficienteTarifa obtenerID(Integer id) {
		return coeficienteTarifaDAO.obtenerID(id);
	}

	@Transactional
	public CoeficienteTarifa suscribir(CoeficienteTarifa entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return coeficienteTarifaDAO.suscribir(entidad);
	}

	@Transactional
	public CoeficienteTarifa actualizacion(CoeficienteTarifa entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return coeficienteTarifaDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(CoeficienteTarifa entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		coeficienteTarifaDAO.actualizacion(entidad);
	}

	public List<CoeficienteTarifa> buscar(String nomb) {
		return coeficienteTarifaDAO.buscar(nomb);
	}
}
