/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.EmpresaDAO;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("empresaService")
public class EmpresaServiceImpl implements EmpresaService {

    @Autowired
    private EmpresaDAO empresaDAO;

    public List<Empresa> obtenerTodos() {
        return empresaDAO.obtenerTodos();
    }

    public Empresa obtenerID(Integer id) {
        return empresaDAO.obtenerID(id);
    }

    @Transactional
    public Empresa suscribir(Empresa entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return empresaDAO.suscribir(entidad);
    }

    @Transactional
    public Empresa actualizacion(Empresa entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return empresaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Empresa entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        empresaDAO.actualizacion(entidad);
    }

    public List<Empresa> buscar(String nombempresa, Boolean indExterna, Short indTipo) {
        return empresaDAO.buscar(nombempresa, indExterna, indTipo);
    }

    public List<Empresa> buscarTodosExceto(Integer... idEmpresa) {
        return empresaDAO.buscarTodosExceto(idEmpresa);
    }

    public List<Empresa> obtenerIndExternoFalse() {
        return empresaDAO.obtenerIndExternoFalse();
    }

    public List<Empresa> obtenerIndTipo1() {
        return empresaDAO.obtenerIndTipo1();
    }

    public List<Empresa> obtenerIndTipo2() {
        return empresaDAO.obtenerIndTipo2();
    }
}
