package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.OrgaoTramoDAO;
import com.rjconsultores.ventaboletos.entidad.OrgaoTramo;
import com.rjconsultores.ventaboletos.service.OrgaoTramoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("orgaoTramoService")
public class OrgaoTramoServiceImpl implements OrgaoTramoService {

	@Autowired
	private OrgaoTramoDAO orgaoTramoDAO;

	public List<OrgaoTramo> obtenerTodos() {
		return orgaoTramoDAO.obtenerTodos();
	}

	public OrgaoTramo obtenerID(Integer id) {
		return orgaoTramoDAO.obtenerID(id);
	}

	@Transactional
	public OrgaoTramo suscribir(OrgaoTramo entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return orgaoTramoDAO.suscribir(entidad);
	}

	@Transactional
	public OrgaoTramo actualizacion(OrgaoTramo entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return orgaoTramoDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(OrgaoTramo entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		orgaoTramoDAO.actualizacion(entidad);
	}
}
