/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PricingPuntoVentaDAO;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingPuntoVenta;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.service.PricingPuntoVentaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("pricingPuntoVentaService")
public class PricingPuntoVentaServiceImpl implements PricingPuntoVentaService {

    @Autowired
    private PricingPuntoVentaDAO pricingPuntoVentaDAO;

    public List<PricingPuntoVenta> obtenerTodos() {
        return pricingPuntoVentaDAO.obtenerTodos();
    }

    public PricingPuntoVenta obtenerID(Integer id) {
        return pricingPuntoVentaDAO.obtenerID(id);
    }

    @Transactional
    public PricingPuntoVenta suscribir(PricingPuntoVenta entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return pricingPuntoVentaDAO.suscribir(entidad);
    }

    @Transactional
    public PricingPuntoVenta actualizacion(PricingPuntoVenta entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return pricingPuntoVentaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PricingPuntoVenta entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        pricingPuntoVentaDAO.actualizacion(entidad);
    }

    public Boolean obtenerPricingPuntoVenta(Pricing pricing, PuntoVenta puntoVenta) {
        return pricingPuntoVentaDAO.obtenerPricingPuntoVenta(pricing, puntoVenta);
    }
}
