/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.TipoEventoExtraDAO;
import com.rjconsultores.ventaboletos.entidad.TipoEventoExtra;
import com.rjconsultores.ventaboletos.exception.BusinessException;
import com.rjconsultores.ventaboletos.service.TipoEventoExtraService;
import com.rjconsultores.ventaboletos.service.EventoExtraService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("tipoEventoExtraService")
public class TipoEventoExtraServiceImpl implements TipoEventoExtraService {

    @Autowired
    private TipoEventoExtraDAO tipoEventoExtraDAO;
    @Autowired
    private EventoExtraService eventoExtraService;

    public List<TipoEventoExtra> obtenerTodos() {
        return tipoEventoExtraDAO.obtenerTodos();
    }

    public TipoEventoExtra obtenerID(Integer id) {
        return tipoEventoExtraDAO.obtenerID(id);
    }
    @Transactional
    public TipoEventoExtra suscribir(TipoEventoExtra entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return tipoEventoExtraDAO.suscribir(entidad);
    }

    @Transactional
    public TipoEventoExtra actualizacion(TipoEventoExtra entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return tipoEventoExtraDAO.actualizacion(entidad);
    }

    @Transactional(rollbackFor=BusinessException.class)
    public void borrar(TipoEventoExtra entidad) throws BusinessException {
    	
    	if (!eventoExtraService.obtenerPorTipo(entidad).isEmpty()) {
    		throw new BusinessException("editarTipoEventoExtraController.MSG.evento");    		
    	}
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        tipoEventoExtraDAO.actualizacion(entidad);
    }

	@Override
	public List<TipoEventoExtra> buscar(String descingreso) {
		return tipoEventoExtraDAO.buscar(descingreso);
	}

    
}
