/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.UsuarioDAO;
import com.rjconsultores.ventaboletos.entidad.Empleado;
import com.rjconsultores.ventaboletos.entidad.Usuario;
import com.rjconsultores.ventaboletos.entidad.UsuarioPerfil;
import com.rjconsultores.ventaboletos.service.UsuarioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("usuarioService")
public class UsuarioServiceImpl implements UsuarioService, UserDetailsService {

    @Autowired
    private UsuarioDAO usuarioDAO;

    public List<Usuario> buscarPeloNome(String nome) {
        return usuarioDAO.buscarPeloNome(nome);
    }

    public String encriptarSenha(String login, String senha) {
        org.springframework.security.authentication.encoding.Md5PasswordEncoder a =
                new org.springframework.security.authentication.encoding.Md5PasswordEncoder();

        return a.encodePassword(senha, login);
    }

    public List<Usuario> obtenerTodos() {
        return usuarioDAO.obtenerTodos();
    }

    public Usuario obtenerID(Integer id) {
        return usuarioDAO.obtenerID(id);
    }

    @Transactional
    public Usuario suscribir(Usuario entidad) {
        entidad.setUsuariomodifId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return usuarioDAO.suscribir(entidad);
    }

    @Transactional
    public Usuario actualizacion(Usuario entidad) {
        entidad.setUsuariomodifId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return usuarioDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Usuario entidad) {

        entidad = obtenerID(entidad.getUsuarioId());

        for (UsuarioPerfil up : entidad.getUsuarioPerfilList()) {
            up.setUsuariomodifId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            up.setFecmodif(Calendar.getInstance().getTime());
            up.setActivo(Boolean.FALSE);
        }

        entidad.setUsuariomodifId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        usuarioDAO.actualizacion(entidad);
    }

    public Usuario buscarPeloNomeSenha(String stUsuario, String senha) {
        return usuarioDAO.buscarPeloNomeSenha(stUsuario, senha);
    }

    public UserDetails loadUserByUsername(String string)
            throws UsernameNotFoundException, DataAccessException {
        return UsuarioLogado.getUsuarioLogado();
    }

    public List<Usuario> buscarPorEmpleado(Empleado empleado) {
        return usuarioDAO.buscarPorEmpleado(empleado);
    }

    public List<Usuario> buscarPelaCveUsuario(String cveUsuario) {
        return usuarioDAO.buscarPelaCveUsuario(cveUsuario);
    }
}
